<?php 
/*#################################################################*\
|# Licence Number 0DT7-0122-0NW1-0210
|# -------------------------------------------------------------   #|
|# Copyright (c)2010 PHP Link Directory.                           #|
|# http://www.phplinkdirectory.com                                 #|
\*#################################################################*/
	
/**
# ################################################################################
# Project:   PHP Link Directory
#
# **********************************************************************
# Copyright (C) 2004-2009 NetCreated, Inc. (http://www.netcreated.com/)
#
# This software is for use only to those who have purchased a license.
# A license must be purchased for EACH installation of the software.
#
# By using the software you agree to the terms:
#
#    - You may not redistribute, sell or otherwise share this software
#      in whole or in part without the consent of the the ownership
#      of PHP Link Directory. Please contact david@david-duval.com
#      if you need more information.
#
#    - You agree to retain a link back to http://www.phplinkdirectory.com/
#      on all pages of your directory in you purchased the $25 version
#      of the software.
#
# License holders are entitled to upgrades to the 3.4 branch of the software
# as they are made available at http://www.phplinkdirectory.com/
#
# In some cases, license holders may be required to agree to changes
# in the software license before receiving updates to the software.
# **********************************************************************
#
# For questions, help, comments, discussion, etc., please join the
# PHP Link Directory Forum http://www.phplinkdirectory.com/forum/
#
# @link           http://www.phplinkdirectory.com/
# @copyright      2004-2009 NetCreated, Inc. (http://www.netcreated.com/)
# @projectManager David DuVal <david@david-duval.com>
# @package        PHPLinkDirectory
# @version        4.0.0
# ################################################################################
*/
class LatestArticleComments extends Widget {
	var $name;
	var $type;
	var $tpl;
	
	function LatestArticleComments($name='', $type='', $tpl='') {
		$this->name = $name;
		$this->type = $type;
		$this->tpl = get_widget_tpl($name);
		$this->tpl->assign('date_format', '%D %H:%M:%S');
	}
	
	function getContent() {
		global $db;
		global $tables;
	    
		$set = $this->getFrontSettings();
	    
		if (intval($set['NO_OF_COMMENTS']) > 0) {
			$limit = intval($set['NO_OF_COMMENTS']);
		} else {
			$limit = 10;
		}
		
		$qry = "SELECT ac.*, a.`TITLE`, DATE_FORMAT(ac.DATE_ADDED, '%b %d') AS `DAT` 
								FROM `{$tables['articlecomment']['name']}` ac LEFT JOIN `{$tables['article']['name']}` a
								ON (ac.`ARTICLE_ID` = a.`ID`) 
								WHERE (ac.`STATUS` = '2') 
								ORDER BY ac.`DATE_ADDED` DESC LIMIT 0, ".$limit;
		if ($set['CACHE_RESULTS'] == "Yes") {
			$latest_com = $db->CacheGetAll($qry);
		} else {
			$latest_com = $db->CacheGetAll($qry);
		}
		
		foreach($latest_com as $k => $v) {
        	$latest_com[$k]['SEO_URL'] = seo_url($v['ARTICLE_ID'], $v['TITLE'], REWRITE_TYPE, REWRITE_EXT, 1);
    	}
    	$this->tpl->assign('latest_com', $latest_com);
    	
    	if ($set['DISPLAY_IN_BOX'] == "No") {
			$this->tpl->assign('show_title', 1);
		}
		$this->tpl->assign("TITLE", $set['TITLE']);
    	
		return $this->tpl->fetch('content.tpl');
	}
}

?>